Subject: Re: B20: stdio bugs with 'merge' & 'gzip'
From: Earnie Boyd <[email-masked]>
To: Dmitry Karasik <[email-masked]>
Cc: cygwin users <[email-masked]>
Date: Fri, 3 Dec 1999 10:52:38 -0800 (PST)

--- Dmitry Karasik <[email-masked]> wrote:
> 
> Hi Earnie!
> 
> >
> > There is a bug in the stock b20.1 cygwin1.dll that could cause you to
> think
> > that gzip is buggy.  The bug isn't in gzip it is in the cygwin1.dll.  See
> my
> > webpage for more details.
> 
> That's right, of course, - did I said that stdio functions is implemented in
> gzip?
> 
> >
> > As far as I can tell merge.exe isn't a part of the Cygwin package.  If you
> > `cygcheck merge.exe' you'll see a list of dll's the binary is dependant
> on.  Is
> > cygwin1.dll one of them?
> 
> merge.exe is from ftp://sunsite.auc.dk/pub/cygwin/cygwin-b20/full.exe
> If it's not part of the package, then I don't know. The only truth is, that
> merge.exe not contains any
> link to cygnus dlls, but it calls diff3.exe, which does. And diff3.exe from
> b19 has no such bug.
> I think that bug is somewhere with pipe implementation.
> I have strange situation here - from one hand, the bug it clearly
> reproduceable with perl script, but it's possible that
> perl itself has a bug. But from the other hand, merge.exe contains no perl,
> and there's still the bug.
> I tried to reproduce the same sequence with C, but everything works fine.
> But, then, if we take C source :
> #include <stdio.h>
> int main( void){ printf("hello world\n"); return 0; }
> then, compiled with gcc from b20 it produces the bug,
> but with b19 and m$vc compiler produces no bug.
> 
> perl script is ( if anyone cares):
> 
> open FH, "a.exe|" or die $!;
> my $c = 0;
> $c += length while <FH>;
> close FH or die $!;
> print "$c bytes read, try to input anything...\n";
> $_ = <>;
> 
> a.exe is compiled C source above, if any, and bug is that there goes no
> input echo.
> 
> Sincerely,
>    Dmitry
> 
> > > > Cygwin Newbies, please visit
> > > > <http://www.freeyellow.com/members5/gw32/index.html>
> > > The link is broken. Maybe microsoft.com will do? :E
> > Try again.
> Next year? It's dead like a ... whatever :)

Nope. It lives.

The essence of the page states that yes, there is a bug in processing the of
pipes and redirection (and therefore the stdio routines) for the stock
cygwin1.dll.  You need to upgrade with at least the Jan 15th, 1999 snapshot. 
You may find this and more current snapshots at
http://sourceware.cygnus.com/cygwin/snapshots/.  

You still need to modify your path and get rid of multiple cygwin dlls.  But,
to not do so is your choice.

=====
Earnie Boyd <mailto:[email-masked]>
Cygwin Newbies, please visit
<http://www.freeyellow.com/members5/gw32/index.html>
__________________________________________________
Do You Yahoo!?
Thousands of Stores.  Millions of Products.  All in one place.
Yahoo! Shopping: http://shopping.yahoo.com

--
Want to unsubscribe from this list?
Send a message to [email-masked]